clear variables;close all;clc
import matlab.net.* matlab.net.http.* matlab.net.http.io.*
uri = URI('https://api.openai.com/v1/chat/completions');
key % read the private key
%%
for j=6 % only fence AR interface
   files=dir(['Study2input\' num2str(j) '\*.txt']);
    for i=1:length(files)
        text=fileread(['Study2input\' num2str(j) '\' files(i).name]);
        prompt = ['Looking at the participant''s responses, provide a summary of the interface' newline];
        prompt = [prompt text]; %#ok<AGROW>

        body = JSONProvider(struct('model','gpt-4-0613','temperature',0,'n',1,'messages', {{struct('role', 'user','content', prompt')}}));
        response = RequestMessage('post', [HeaderField('Content-Type', 'application/json') HeaderField('Authorization', api_key)], body).send(uri.EncodedURI);

        save(['Study2_gpt4_interface_' num2str(j) '_file_' num2str(i)],'response','prompt')
        response_text = response.Body.Data.choices.message.content;
        disp(['Interface ' num2str(j) ', File: ' num2str(i)])
        disp(response_text);
    end
end

%% Summarize the summaries
disp('DISPLAY OVERALL SUMMARIES')
import matlab.net.* matlab.net.http.* matlab.net.http.io.*
uri = URI('https://api.openai.com/v1/chat/completions');
for j=6 % only the fence AR interface
    text=[];
    for i=1:30 % loop over participants
        load(['Study2output\Study2_gpt4_interface_' num2str(j) '_file_' num2str(i)])
        try
            response_text = response.Body.Data.choices.message.content;
            if ~isempty(response_text)
                text=[text 'Participant No. ' num2str(i) ': ' response_text(2:end) newline]; %#ok<AGROW>
            end

        catch error
            length(prompt)
        end
    end
    prompt = ['Looking at the participant''s responses, provide a summary of the interface' newline];
    prompt = [prompt text]; %#ok<AGROW>
    body = JSONProvider(struct('model','gpt-4-0613','temperature',0,'n',1,'messages', {{struct('role', 'user','content', prompt')}}));
    response = RequestMessage('post', [HeaderField('Content-Type', 'application/json') HeaderField('Authorization', api_key)], body).send(uri.EncodedURI);
    response_text = response.Body.Data.choices.message.content;
    disp(response_text)
end
