clear variables;close all;clc

import matlab.net.* matlab.net.http.* matlab.net.http.io.*
key % read the private key
header = [HeaderField('Content-Type', 'application/json')
    HeaderField('Authorization', api_key)]';
uri = URI('https://api.openai.com/v1/chat/completions');

%% Sending Interviews to API
for j=6 % only fence
    files=dir(['Study2input\' num2str(j) '\*.txt']);
    for i=1:length(files)
        text=fileread(['Study2input\' num2str(j) '\' files(i).name]);
        import matlab.net.*

        prompt = ['Looking at the participant''s responses, provide a summary of the interface' newline];
        prompt = [prompt text]; %#ok<AGROW>

        body = JSONProvider(struct('model','gpt-3.5-turbo','temperature',0,'n',1,'messages', {{struct('role', 'user','content', prompt')}}));
        response = RequestMessage('post', header, body).send(uri.EncodedURI);

        save(['Study2_interface_' num2str(j) '_file_' num2str(i)],'response','prompt')
        response_text = response.Body.Data.choices.message.content;
        disp(['Interface ' num2str(j) ', File: ' num2str(i)])
        disp(response_text);
    end
end

%% Summarize the summaries
tic
import matlab.net.* matlab.net.http.* matlab.net.http.io.*
disp('DISPLAY OVERALL SUMMARIES')
header = [HeaderField('Content-Type', 'application/json')
    HeaderField('Authorization', api_key)]';
uri = URI('https://api.openai.com/v1/chat/completions');

for j=6 % only the fence interface
    text=[];

    for i=1:30 % loop over participants
        load(['Study2output\Study2_interface_' num2str(j) '_file_' num2str(i)])
        try
            response_text = response.Body.Data.choices.message.content;
            if ~isempty(response_text)
                text=[text 'Participant No. ' num2str(i) ': ' response_text(2:end) newline]; %#ok<AGROW>
            end

        catch error
            length(prompt)
        end
    end

    import matlab.net.*
    prompt = ['Looking at the participant''s responses, provide a summary of the interface' newline];
    prompt = [prompt text]; %#ok<AGROW>

    body = JSONProvider(struct('model','gpt-3.5-turbo','temperature',0,'n',1,'messages', {{struct('role', 'user','content', prompt')}}));
    response = RequestMessage('post', header, body).send(uri.EncodedURI);
    response_text = response.Body.Data.choices.message.content;
    disp(['Participant ' num2str(j) ': '])
    disp(response_text)
end
toc % output time taken