clear variables;close all;clc

import matlab.net.* matlab.net.http.* matlab.net.http.io.*
key % read the private key
header = [HeaderField('Content-Type', 'application/json')
    HeaderField('Authorization', api_key)]';
uri = URI('https://api.openai.com/v1/chat/completions');

for j=6 % Virtual fence
    files=dir(['Study2input\' num2str(j) '\*.txt']);

    prompt = ['Looking at the following interviews, provide a table with the first column 20 statements, and the second column the total number of participants mentioning it.' newline];
    text_all=[];
    for i=1:length(files) % loop over participants
        text=fileread(['Study2input\' num2str(j) '\' files(i).name]);
        text_all=[text_all newline ['Interview with participant number ' num2str(i) ': '] newline text]; %#ok<AGROW>
    end
    prompt=[prompt newline text_all]; %#ok<AGROW>
    body = JSONProvider(struct('model','gpt-3.5-turbo-16k','temperature',0,'n',1,'messages', {{struct('role', 'user','content', prompt')}}));
    response = RequestMessage('post', header, body).send(uri.EncodedURI);
    response_text = response.Body.Data.choices.message.content;
    disp(['Interface ' num2str(j) ', File: ' num2str(i)])
    disp(response_text);
end
